// Header File
// Created 11/11/2003; 9:00:45 PM
static inline void Load_Gfx(void);
//static inline unsigned char *Get_Data_Ptr(const char*, unsigned short);
static inline void SafeUnlock(const char *Filename);

/* Global Pointers to Data in the 'hockgfx' File */
unsigned short *Hand;
unsigned short (*PlrGfx)[32];
unsigned short (*SkinnyGfx)[36];
unsigned char  (*LevelData)[Width];
unsigned short (*Blocks)[32];
unsigned short (*Arrows)[32];
unsigned char *Easternl;
unsigned char *Easternd;
unsigned char *Westernl;
unsigned char *Westernd;
unsigned char *C_Mask;
unsigned char *RLE_NHLd;
unsigned char *RLE_NHLl;
unsigned long *Flower;
unsigned long *LinkPlay;
unsigned char (*Font)[24];
unsigned char (*Starting_Pos)[2];
Names *Default_Western;
Names *Default_Eastern;

static inline void Load_Gfx(void) {
	SYM_ENTRY *SymPtr;
	if ((SymPtr = SymFindPtr(SYMSTR("hockgfx"), 0)) == NULL)
		ERROR(EXTERNAL_FILE_HOCKGFX);  // File not found
	Hand = (unsigned short*)HLock(SymPtr->handle);
	if (Hand == NULL)
		ERROR(EXTERNAL_FILE_HOCKGFX);
	Hand     += 1;
	//Hand      = (unsigned short*)Get_Data_Ptr("hockgfx", 0);
	PlrGfx    = (unsigned short (*)[32])((char*)Hand + 64);
	SkinnyGfx = (unsigned short (*)[36])((char*)PlrGfx + (22 * 32 * 2));
	LevelData = (unsigned char (*)[Width])((char*)SkinnyGfx + (10 * 36 * 2));
	Blocks    = (unsigned short (*)[32])((char*)LevelData + (Height * Width));
	Arrows    = (unsigned short (*)[32])((char*)Blocks + (88 * 32 * 2));
	Easternl  = (unsigned char *)((char*)Arrows + (4 * 32 * 2));
	Easternd  = (unsigned char *)((char*)Easternl + 228);
	Westernl  = (unsigned char *)((char*)Easternd + 228);
	Westernd  = (unsigned char *)((char*)Westernl + 228);
	C_Mask    = (unsigned char *)((char*)Westernd + 228);
	Flower    = (unsigned long *)((char*)C_Mask   + 228);
	LinkPlay  = (unsigned long *)((char*)Flower   + 192);
	RLE_NHLd  = (unsigned char *)((char*)LinkPlay + (21 * 3 * 4));
	//RLE_NHLd  = (unsigned char *)((char*)C_Mask   + 228);
	RLE_NHLl  = (unsigned char *)((char*)RLE_NHLd + 1517);
	Font      = (unsigned char (*)[24])((char*)RLE_NHLl + 1500);
	Starting_Pos = (unsigned char (*)[2])((char*)Font + (39 * 24));
	Default_Western = (Names *)((char*)Starting_Pos + (9 * 2));
	Default_Eastern = (Names *)((char*)Default_Western + 1360);
}

/*static inline unsigned char *Get_Data_Ptr(const char *Filename, unsigned short Offset) {
	unsigned char *Location;
	SYM_ENTRY *SymPtr;
	HANDLE h;
	
	if ((SymPtr = SymFindPtr(SYMSTR(Filename), 0)) == NULL)
		ERROR(EXTERNAL_FILE_HOCKGFX);  // File not found
	
	h = SymPtr->handle;
	
	Location = (unsigned char*) HLock(h);
	return (Location + 2 + Offset);
}*/

static inline void SafeUnlock(const char *Filename) {
	SYM_ENTRY *SymPtr;
	HANDLE h;
	
	if ((SymPtr = SymFindPtr(SYMSTR(Filename), 0)) == NULL)
		return;  // File not found
	if (SymPtr->flags.bits.locked == FALSE)
		return;  // File is not Locked
	if (!(h = SymPtr->handle))
		return;  // The File's Handle is unusable?
	
	HeapUnlock(h);
}

/*unsigned long Flower[48] =  // (31x16)
{ 0x3C000,0xC7000,0x37EC00,0x29B400,0x7E817E0,0x3973DD18,0x438FF284,0x82981B82,0x63F9DF86,0x3F5E73FE,
	0x1F63C6BC,0x9CCB310,0x8793C10,0x8078010,0x81FF0F0,0xFFC3FE0, // Light
	0x3C000,0xFF000,0x381C00,0x300C00,0x7F7EFE0,0x3E3FF8F8,0x7C7C3C7C,0xFC7C3C7E,0x7DFE3FFE,0x1E3FFC78,
	0x61FF860,0xE03C0F0,0xF87C3F0,0xFFFFFF0,0xFFC7FF0,0xFF00F00,  // Dark
	0xFFFC3FFF,0xFFF00FFF,0xFFC003FF,0xFFC003FF,0xF800001F,0xC0000007,0x80000003,0x1,0x80000001,  // Mask
	0xC0000001,0xE0000003,0xF000000F,0xF000000F,0xF000000F,0xF000000F,0xF003C01F
};

unsigned long LinkPlay[21 * 3] = {  // (27x21)
	// Layer 1 (Light)
	0x10000,0x7FE30000,0x8017FB40,0xBF530020,0xBE910000,0xBC000020,0xB9FF8020,0xB2004400,0x82FD4C20,0xFAFA5F40,
	0xFAF54C00,0xDAEB4400,0xF2D74000,0xFA004000,0xFBFFC000,0x7BFDC000,0x378C000,0x3DDC000,0x3FFC000,0x3E78000,
	0x1FF0000,
	// Layer 2 (Dark)
	0x10000,0x7FE30000,0xFFF7FB40,0xC0330020,0xC0310000,0xC0000020,0xC1FF8020,0xC3FFC400,0xFB00CC20,0xFB00DF40,
	0xFB00CC00,0xDB00C400,0xF300C000,0xFBFFC000,0xFBFFC000,0x7BFDC000,0x378C000,0x3DDC000,0x3FFC000,0x3FF8000,
	0x1FF0000,
	// Layer 3 (Mask)
	0xFFFEFFFF,0x801CFFFF,0x804BF,0xCFFDF,0xEFFFF,0xFFFDF,0x7FDF,0x3BFF,0x33DF,0x20BF,0x33FF,0x3BFF,
	0x3FFF,0x3FFF,0x3FFF,0x80003FFF,0xFC003FFF,0xFC003FFF,0xFC003FFF,0xFC007FFF,0xFE00FFFF
};*/