// C Source File
// Created 9/7/2003; 6:41:15 PM
#include "All.h"
//#include "TempDat.h"
//#include "Teams.h"
#include "HockeyGfx.h"
#include "faststr.h"
static inline void Initialize_Game(void);

/* ------------------------------------------------------------------ */
/*																																		*/
/*												Hockey 68k v2.00														*/
/*													- By Fisch -															*/
/*																																		*/
/*											 phishfud@elknet.net													*/
/*																																		*/
/*																																		*/
/*	Started: September 7, 2003																				*/
/*	Beta1:	 October 30, 2003																					*/
/*	Public:  December 02, 2003																				*/
/*	Ended:   																													*/
/*																																		*/
/*	I hope the source is fairly readable and well structured.  If			*/
/*	there is a problem/bug with any aspect of the Game, or you know		*/
/*	a way to improve it in any way, your e-mail is very welcome.  I		*/
/*	have learned So much working on this Game and I hope that the 		*/
/*	source will help others as well.																	*/
/*																																		*/
/* ------------------------------------------------------------------ */

/*#ifdef USE_TI92PLUS  // Just a reminder to myself
#warning "compiling for Ti-92+/v200"
#else
#warning "compiling for Ti-89"
#endif*/

/*	Globals	 */
INT_HANDLER interrupt1;
INT_HANDLER interrupt5;
void   *dbuffer;
Team   *Team1;
Team   *Team2;
Puck   *puck;
Map    *map;
Game   *game;
Clock  *clock;
Plane  *plane;
config *Config;
char   *Home;
void   *Bulk;
char Link;
char Calc;
short Cur_Plr;
short HW1;
short Control_Delay;
#ifdef COMPRESSION
unsigned char *NHLl;
unsigned char *NHLd;
#endif
Names *Western;
Names *Eastern;

/* Base taken from TICT Tutorial SP12, Example 3 and modified */
/* Used for Keeping track of Time during the Games */
DEFINE_INT_HANDLER (CLOCK_TIMER) {
	if (clock->Reset_Time) {
		clock->Mseconds50 = clock->Seconds = clock->Minutes = clock->Reset_Time = 0;
	}
	//------------------------------------------
	// count interrupts only if running is not 0
	//------------------------------------------
	else if (clock->Running == TRUE && ++clock->Mseconds50 >= 19) {
		clock->Mseconds50 -= 19;
		if (++clock->Seconds >= 60) {
			clock->Seconds -= 60;
			++clock->Minutes;
			// There is no need for hours or days because the hockey matches cannot last that long
		}
	}
}

// Main Function
void _main(void)
{
	TRY
	
	Initialize_Game();
	
	#if !defined(DEBUG)
	Show_Title();
	#endif
	
	Main_Menu();
	
	//FINALLY // (caused random Address Error crashes upon program exit in v0.62)
	ONERR
	// <error handler>
	LeadOut2();
	
	//ENDFINAL
	ENDTRY
}

//=============================================================================

// VTI detection routine (thanx go to Julien Muchembled)

//=============================================================================
short IsVTI(void);
asm("
IsVTI:
    trap   #12         /* enter supervisor mode. returns old (%sr) in %d0.w   */
    move.w #0x3000,%sr /* set a non-existing flag in %sr (but keep s-flag !!) */
    swap   %d0         /* save %d0.w content in upper part of %d0             */
    move.w %sr,%d0     /* get %sr content and check for non-existing flag     */
    btst   #12,%d0     /* this non-existing flag can only be set on the VTI   */
    bne    __VTI           
    swap   %d0         /* restore old %sr content and return 0                */
    move.w %d0,%sr
    moveq  #0,%d0
    rts
__VTI:
    swap   %d0         /* restore old %sr content and return 1                */
    move.w %d0,%sr
    moveq  #1,%d0
    rts
");

/* Initializes and Preps the Game */
static inline void Initialize_Game(void) {
	/*	Disable old interrupts and install our own dummy interrupts	 */
	interrupt1 = GetIntVec(AUTO_INT_1);
	interrupt5 = GetIntVec(AUTO_INT_5);
	SetIntVec(AUTO_INT_1, DUMMY_HANDLER);
	/*	-----------------------------------------------------------	 */
	short a;
	Bulk = NULL;
	Home = NULL;
	Western = NULL;
	Eastern = NULL;
	
	// Grayscale is messed up on HW1 normally, so we have to check if it is an HW1 and adjust
	short *hwptr = (short *) FL_getHardwareParmBlock();
	unsigned short HardWareVersion = *hwptr;
	HW1 = (HardWareVersion <=20);
	if (IsVTI()) {
		HW1 = TRUE;
		ST_helpMsg("Warning, Game Speed is Fast on VTI");
	}
	if ((Home = malloc(LCD_SIZE)) == NULL) {
		ST_helpMsg("Error, Not Enough Memory.  Free up RAM");
		LeadOut();
	}
	LCD_save(Home);  // Save LCD HomeScreen Contents
	
	/* Allocate all memory in one block, and then initiate the pointers afterward */
	/* -- Suggested by Lionel Debroux -- */
	#ifdef COMPRESSION
	if ((Bulk = malloc(Bulk_Size + 4002)) == NULL)
		ERROR(MEMORY);
	#else
	if ((Bulk = malloc(Bulk_Size)) == NULL)
		ERROR(MEMORY);
	#endif
	
	// Setup Pointers, within the allocated Bulk block
	Team1   = (Team*)Bulk;
	Team2   = (Team*)((char*)Team1 + sizeof(Team));
	puck    = (Puck*)((char*)Team2 + sizeof(Team));
	map     = (Map*)((char*)puck   + sizeof(Puck));
	game    = (Game*)((char*)map   + sizeof(Map));
	clock   = (Clock*)((char*)game + sizeof(Game));
	dbuffer = (char*)((char*)clock + sizeof(Clock));
	Config  = (config*)((char*)dbuffer + GRAYDBUFFER_SIZE);
	plane   = (Plane*)((char*)Config + sizeof(config));
	#ifdef COMPRESSION
	NHLl    = (unsigned char*)((char*)plane + sizeof(Plane));
	NHLd    = (unsigned char*)((char*)NHLl + 2001);
	#endif
	/* Initiate all other values */
	for(a = 3; a--;) {
		Team1->plrs[a] = NULL;
		Team2->plrs[a] = NULL;
	}
	game->Teams_Changed = FALSE;
	game->Friction      = TRUE;
	game->Distortion    = FALSE;
	Compatibility();
	Allocate_Players(Team1);
	Allocate_Players(Team2);
	randomize();
	
	// Take care of the Game's Clock values
	clock->Running    = 0;
	clock->Reset_Time = 1;
	SetIntVec(AUTO_INT_5, CLOCK_TIMER);  // Turn the Clock Interrupt On
	// The Clock Interrupt uses values in the clock struct, which has to be allocated before 
	// the clock can be turned on
	
	/* ----------------------------------------------------- */
	/* 								Load all External Data								 */
	/* -----------------------------------------------------
	   Hockey exceeded the 64kb Program Size Limit, so I had 
	   to put some of the Data into external Files.  For 
	   more information, look in the SaveGfx Project in the 
	   External Data Folder or in the External.c File.
	   ----------------------------------------------------- */
	Load_Gfx();			// Load Graphics from the .......................... "hockgfx" File
	Load_Config();	// Load the User's Configurational Settings from the "hockycfg" File
	Load_Teams();		// Load the User Customizable Teams from the ....... "hockteam" File
	
	#ifdef COMPRESSION
	RLE_Decompress(RLE_NHLl, NHLl, 1999);  // Buggy...
	RLE_Decompress(RLE_NHLd, NHLd, 1999);
	*((char*)NHLl + 1) = 0xE7;
	*((char*)NHLd + 1) = 0x18;
	#endif
	
	if (SetupCharSet() == FALSE)  // Set up the (Beta) Fast String Drawing Routines by TICT
		ERROR(FONT_LOADING);
	
	if (!GrayOn())  // Turn Grayscale on
		ERROR(MEMORY);
	
	GrayDBufInit(dbuffer); // enable double-buffering
}

void Allocate_Players(Team *team) {
	short Loop;
	
	for(Loop = 0; Loop < 3; Loop++) {
		if ((team->plrs[Loop] = malloc(sizeof(Plr))) == NULL)
			ERROR(MEMORY);
	}
}

// Initializes some Calculator Constants, depending on what calc type the game is being run on
void Compatibility(void) {
	Config->Keys[0] = (RowKey) {RR_ESC};
	Config->Keys[1] = (RowKey) {RR_UP};
	Config->Keys[2] = (RowKey) {RR_LEFT};
	Config->Keys[3] = (RowKey) {RR_DOWN};
	Config->Keys[4] = (RowKey) {RR_RIGHT};
	Config->Keys[5] = (RowKey) {RR_APPS};
	Config->Keys[6] = TI89 ? (RowKey) {RR_2ND} : (TI92PLUS ? (RowKey) {RR_F1} : (RowKey) {RR_HAND});
	Config->Keys[7] = TI89 ? (RowKey) {RR_SHIFT} : (TI92PLUS ? (RowKey) {RR_F5} : (RowKey) {RR_F1});
	Config->Keys[8] = TI89 ? (RowKey) {RR_DIAMOND} : (TI92PLUS ? (RowKey) {RR_F2} : (RowKey) {RR_Q});
	Config->Keys[9] = TI89 ? (RowKey) {RR_F5} : (TI92PLUS ? (RowKey) {RR_F4} : (RowKey) {RR_F3});
	Config->Keys[10] = (RowKey) Config->Keys[6];
	
	if (TI89) {
		memcpy(plane, &(Plane) {
			11, 7, 94, 60, 58, 100, 40, 41, 20
		}, sizeof(Plane));
	} else {
		memcpy(plane, &(Plane) {
			16, 9, 122, 90, 88, 150, 60, 52, 26
		}, sizeof(Plane));
	}
}

/* Uh-Oh */
void ERROR(const unsigned char error) {
	static const char * const Error_Msg[8] = {
		"Not enough Memory", 
		"Hockey needs 80,000 bytes of RAM to run", 
		"Link Error", 
		"Check Link Connection", 
		"Error loading Teams", 
		"Make sure hockgfx file is on calc", 
		"Error Loading Fonts", 
		"Contact phishfud@elknet.net"
	};
	
	// The 80,000 Byte number was found by using Command Post's Low Ram Simulation, by Greg Dietsche
	if (GrayCheckRunning() == TRUE) {  // Check if Grayscale is turned on yet
		if (dbuffer) {  // Check if double-buffering is enabled
			ClearGrayScreen2B(Activel, Actived);
			GrayDBufSetActiveAMSPlane(DARK_PLANE);
		} else {
			ClearGrayScreen();
			GraySetAMSPlane(DARK_PLANE);
		}
	} else {
		PortSet(LCD_MEM, 239, 127);
		clrscr();
	}
	
	/* ----------------------------------------------------------------------------------
		 x << 1 (shifting x to the left 1 bit), is the same as x * 2 (multiplying x by 2)
		 Bit shifting is very important and pretty easy to use once you get the hang of it.
		 Bit shifting is faster than regular multiplication most of the time
	 	 x << n is the same as multiplying x * 2^n
	 	 Likewise, x >> n is the same as dividing x / 2^n
	   ---------------------------------------------------------------------------------- */
	FontSetSys(F_6x8);  // Medium Font
		printf_xy(0, 0, "%s", (char*) Error_Msg[error << 1]);
	FontSetSys(F_4x6);  // Smallest Font
		printf_xy(0, LCD_HEIGHT - 6, "%s", (char*) Error_Msg[(error << 1) + 1]);
	OSLinkOpen();
	/*while(!(_KeyCheck(CONFIRMKEY) || _KeyCheck(ESCKEY) || _KeyCheck(TEACHERKEY) || _keytest(RR_ENTER) || 
	(CALCULATOR && _keytest(RR_ENTER1)) || (CALCULATOR && _keytest(RR_ENTER2))));*/
	while(!(_keytest(RR_ENTER) || (CALCULATOR && _keytest(RR_ENTER1)) || (CALCULATOR && _keytest(RR_ENTER2))
	|| _keytest(RR_ESC)))
	PortRestore();
	
	if (error == LINK_ERROR && !_keytest(RR_ESC)) {
		Main_Menu();
	}
	LeadOut();
}

void __attribute__ ((noreturn)) LeadOut(void)  // Thanks to Kevin Kofler for this suggestion
{
	ER_success();  // Before exiting from inside of a TRY block, ER_success(); MUST be called
	LeadOut2();
	
	exit(0);  // Dummy Exit so the compiler won't give Warnings about this being a noreturn function
	// It will Never be called, though, because LeadOut2 calls exit(0); first.
}

/* Frees all possibly allocated memory, cleans up and exits */
void __attribute__ ((noreturn)) LeadOut2(void) {
	short a;
	
	Save_Config();
	if (game && game->Teams_Changed == TRUE)  // Only Save the Teams if the User has made Changes
		Save_Teams();
	SafeUnlock("hockgfx");
	OSLinkClose();  // Clean up Link
	if (Western)	free(Western);
	if (Eastern)	free(Eastern);
	if (plane) {
		while(_KeyCheck(TEACHERKEY));
	}
	
	GrayOff();
	SetIntVec(AUTO_INT_1, interrupt1);  // Restore default interrupts
	SetIntVec(AUTO_INT_5, interrupt5);
	
	/*	Free all allocated Space	*/
	if (Bulk) {
		for(a = 3; a--;) {  // Each player on each team has to be freed separately
			if (Team1->plrs[a])
				free(Team1->plrs[a]);
			if (Team2->plrs[a])
				free(Team2->plrs[a]);
		}
		free(Bulk);  // Free the main bulk of Allocated memory
	}
	
	// Restore the Home Screen, this is pretty much what #define SAVE_SCREEN does
	if (Home) {
		GKeyFlush();
		
		LCD_restore(Home);
		ST_helpMsg("Hockey 68k v2.00  --By Fisch");
		free(Home);
	}
	
	exit(0);
}