// C Source File
// Created 9/14/2003; 3:09:22 PM
#include "All.h"
static inline void Draw_Puck(short, short);

/* Move the Puck and check for Collisions/Goals scored */
void Update_Puck(void) {
	/* If the puck is being controlled by a player, the player will be the center of the camera */
	if (puck->Is_Controlled == FALSE) {
		// Friction with the Ice that gradually makes the puck stop
		if (game->Friction != FALSE) {
			puck->addx += ((puck->addx < 0) - (puck->addx > 0)) << 1;
			puck->addy += ((puck->addy < 0) - (puck->addy > 0)) << 1;
		}
		
		puck->x += (puck->addx >> 5);
		puck->y += (puck->addy >> 5);
		
		// Check if puck hit Left Goal
		if (Puck_Hit_Goal1(puck->x, puck->y)) {
			if (puck->y < 135 && puck->y >= 82) {
				if (puck->addx > 0 && puck->x < 58) {
					puck->x = 46;
					puck->addx = -ABS(puck->addx);
				} else if (puck->addx < 0 && puck->x > 56) {  /* !!!GOAL!!! */
					game->Status = Level_Scored;
				}
			}
			if (Puck_Hit_Goal1(puck->x, puck->y) && game->Status != Level_Scored) {
				if (puck->addy > 0 && puck->y < 86) {
					puck->y = 80;
					puck->addy = -ABS(puck->addy);
				} else if (puck->addy < 0 && puck->y > 132) {
					puck->y = 138;
					puck->addy = ABS(puck->addy);
				}
			}
		} else if (Puck_Hit_Goal2(puck->x, puck->y)) {  // Check if puck hit Right Goal
			if (puck->y < 135 && puck->y >= 82) {
				if (puck->addx > 0 && puck->x < 407) {  /* !!!GOAL!!! */
					game->Status = Level_Scored;
				} else if (puck->addx < 0 && puck->x > 404) {
					puck->x = 414;
					puck->addx = ABS(puck->addx);
				}
			}
			if (Puck_Hit_Goal2(puck->x, puck->y) && game->Status != Level_Scored) {
				if (puck->addy > 0 && puck->y < 86) {
					puck->y = 80;
					puck->addy = -ABS(puck->addy);
				} else if (puck->addy < 0 && puck->y > 132) {
					puck->y = 138;
					puck->addy = ABS(puck->addy);
				}
			}
		}
		
		// Check for collisions with the puck and the sides of the Rink
		if (puck->x < 7) {
			puck->x = 7;
			puck->addx = ABS(puck->addx);
		} else if (puck->x > Max_x + 11) {
			puck->x = Max_x + 11;
			puck->addx = -ABS(puck->addx);
		} if (puck->y < 15) {
			puck->y = 15;
			puck->addy = ABS(puck->addy);
		} else if (puck->y > Max_y + 15) {
			puck->y = Max_y + 15;
			puck->addy = -ABS(puck->addy);
		}
	}
	Draw_Puck(puck->x-(map->camera_x<<4)-map->softx, puck->y-(map->camera_y<<4)-map->softy);
}

/* Draws the puck at a given x,y coordinate with no clipping */
static inline void Draw_Puck(short x, short y) {
	register long           offset = (y<<5)-(y<<1)+((x>>3)&0x1e);
	register long           addr1  = (long)Hiddenl+offset;
	register long           addr2  = (long)Hiddend+offset;
	register unsigned short cnt    = 24-(x&15);
	
	*(long*)addr1|=(long)(0x70)<<cnt;
	*(long*)addr2|=(long)(0x70)<<cnt;
	addr1+=30, addr2+=30;
	*(long*)addr1|=(long)(0xF8)<<cnt;
	*(long*)addr2|=(long)(0xF8)<<cnt;
	addr1+=30, addr2+=30;
	*(long*)addr1|=(long)(0xF8)<<cnt;
	*(long*)addr2|=(long)(0xF8)<<cnt;
	addr1+=30, addr2+=30;
	*(long*)addr1|=(long)(0x70)<<cnt;
	*(long*)addr2|=(long)(0x70)<<cnt;
}