// C Source File
// Created 9/7/2003; 12:06:05 PM
#include "All.h"
//static inline void GrayTile_Clipped(const short, short, unsigned short*);

//void DrawMap(void) {
//	register short x, x2 = -16 - map->softx;
	
	/*	Clearing the screen and then ORing the tiles onto the separate Tilebuffer is about 8fps faster than 
	blitting the tiles on top of the previous tiles	*/
	/*ClearGrayScreen2B(Hiddenl, Hiddend);
	
	for(x = -1; x < plane->SPRWIDTH; ++x, x2+=16) { // Partially unrolled loop for more speed
		GrayTile_Clipped(x2, -16 - map->softy, Blocks[LevelData[map->camera_y-1][map->camera_x+x]]);
		GrayTile_Clipped(x2, -map->softy, Blocks[LevelData[map->camera_y][map->camera_x+x]]);
		GrayTile_Clipped(x2, 16 - map->softy, Blocks[LevelData[map->camera_y+1][map->camera_x+x]]);
		GrayTile_Clipped(x2, 32 - map->softy, Blocks[LevelData[map->camera_y+2][map->camera_x+x]]);
		GrayTile_Clipped(x2, 48 - map->softy, Blocks[LevelData[map->camera_y+3][map->camera_x+x]]);
		GrayTile_Clipped(x2, 64 - map->softy, Blocks[LevelData[map->camera_y+4][map->camera_x+x]]);
		GrayTile_Clipped(x2, 80 - map->softy, Blocks[LevelData[map->camera_y+5][map->camera_x+x]]);
		GrayTile_Clipped(x2, 96 - map->softy, Blocks[LevelData[map->camera_y+6][map->camera_x+x]]);
		if (CALCULATOR) {
			GrayTile_Clipped(x2, 112 - map->softy, Blocks[LevelData[map->camera_y+7][map->camera_x+x]]);
			GrayTile_Clipped(x2, 128 - map->softy, Blocks[LevelData[map->camera_y+8][map->camera_x+x]]);
		}
	}
	//printf_xy(0, 0, "%d  %d  ", map->camera_x, map->softx);
}*/

/* ---------------------------------------CAMERA----------------------------------------
		The Camera always follows the puck and will stay centered on it scrolling vertically.  
		Horizontal scrolling is not centered on the puck, but off to one side so you can view
		more of what's coming better
   ------------------------------------------------------------------------------------- */
void Center_Camera(void) {
	register short Cur_x = (map->camera_x << 4) + map->softx;
	register short Xdif = puck->x - puck->Oldx;
	register short Ydif = puck->y - puck->Oldy;
	
	if (Xdif > 0) {					// Puck is moving Right
		if (Cur_x > puck->x - plane->Camerax_1 && puck->x > plane->Camerax_2)
			Shift_Horizontal(Xdif);
		else if (Cur_x + Xdif + Xdif > puck->x - plane->Camerax_1)  // > puckx - 60
			Shift_Horizontal((puck->x - plane->Camerax_1) - Cur_x);
		else Shift_Horizontal(Xdif + Xdif);
	} else if (Xdif < 0) {	// Puck is moving Left
		if (Cur_x < puck->x - plane->Camerax_3 && puck->x < Max_x - plane->Camerax_4)
			Shift_Horizontal(Xdif);
		else if (Cur_x + Xdif + Xdif < puck->x - plane->Camerax_3)
			Shift_Horizontal((puck->x - plane->Camerax_3) - Cur_x);
		else Shift_Horizontal(Xdif + Xdif);
	}
	
	if ((puck->y > plane->Cameray_1 && Ydif > 0) || (puck->y < Max_y-plane->Cameray_2 && Ydif < 0))
		Shift_Vertical(Ydif);
}

// Move the Camera Horizontally
void Shift_Horizontal(const short No_Lines) {
	
	map->softx += No_Lines;
	
	if (map->softx >= 16 && map->camera_x < Width - plane->SPRWIDTH) {
		++map->camera_x;
		map->softx -= 16;
	} else if (map->softx <= -16 && map->camera_x > 0) {
		--map->camera_x;
		map->softx += 16;
	}
	
	if (map->softx > 16)
		map->softx = 16;
	else if (map->softx + (map->camera_x << 4) < 0)
		map->softx = 0;
}

// Move the Camera Vertically
void Shift_Vertical(const short No_Lines) {
	
	map->softy += No_Lines;
	/*if (game->Distortion != FALSE && map->softy + (map->camera_y << 4) > 0) {
		game->Distortion += No_Lines;
		if (game->Distortion < 1)
			game->Distortion = 16;
		else if (game->Distortion > 16)
			game->Distortion = 1;
	}*/
	
	if (map->softy <= -16 && map->camera_y > 0) {
		--map->camera_y;
		map->softy +=16;
	} else if (map->softy >=16 && map->camera_y < Height - plane->SPRHEIGHT) {
		++map->camera_y;
		map->softy -= 16;
	}
	
	if (map->softy > 16)
		map->softy = 16;
	else if (map->softy + (map->camera_y << 4) < 0)
		map->softy = 0;
}

// By Thomas Nussbaumer - from the Game Construction Kit
/*static inline void GrayTile_Clipped(const short x, short y, unsigned short* sprite1) {
	register long            addr1   = (long) Hiddenl;
	register long            addr2   = (long) Hiddend;
	register unsigned short* sprite2 = sprite1+16;
	register short           h       = 16;
	register long            offset;
	register unsigned short  cnt;
	
	if (y < -15 || y > plane->PlaneHeight || x < -15 || x > LCD_WIDTH)
		return;  // Completely off screen
	
	if (y<0) {  // Clip Above
		sprite1 -= y;
		sprite2 -= y;
		h       += y;
		y        = 0;
	} else if (y > plane->PlaneHeight - 1 - h)  // Clip Below
		h = plane->PlaneHeight - y;
	
	if (x<0) {  // Clip Left
		cnt    = -x+16;
		offset = (y<<5)-(y<<1);
		addr1  += offset;
		addr2  += offset;
		for (;h;--h,addr1+=30,addr2+=30) {
			*(long*)addr1|=(long)(*sprite1++)<<cnt;
			*(long*)addr2|=(long)(*sprite2++)<<cnt;
		}
	} else if (x+16>LCD_WIDTH) {  // Clip Right
		register unsigned short clip=0xffff<<(16-(LCD_WIDTH-x));
		cnt    = 16-(x&15);
		//offset = (y<<5)-(y<<1)+((x>>3)&0x1e);
		offset = (y<<5)-(y+y)+2*(x>>4);  // Suggested change by Bremen
		addr1  += offset;
		addr2  += offset;
		for (;h;--h,addr1+=30,addr2+=30) {
			*(long*)addr1|=(long)(*sprite1++ & clip)<<cnt;
			*(long*)addr2|=(long)(*sprite2++ & clip)<<cnt;
		}
	} else {  // No clipping Necessary
		cnt    = 16-(x&15);
		//offset = (y<<5)-(y<<1)+((x>>3)&0x1e);
		offset = (y<<5)-(y+y)+2*(x>>4);
		addr1  += offset;
		addr2  += offset;
		
		for (;h;--h,addr1+=30,addr2+=30) {
			*(long*)addr1|=(long)(*sprite1++)<<cnt;
			*(long*)addr2|=(long)(*sprite2++)<<cnt;
		}
	}
}*/
static inline void GrayTile_Clipped(short, short, unsigned short*);
void DrawMap(void) {
	ClearGrayScreen2B(Hiddenl, Hiddend);
	
	// Shifting a word (2 Bytes or a short) 15 bits to the right will tell you the sign of the Number
	register unsigned char *Tile = (unsigned char*)LevelData + Width * (map->camera_y - (map->softy < 0)) + 
	(map->camera_x - (map->softx < 0));
	register short x, y;
	asm volatile("
		tst.w %0
		smi.b %0 | if negative fill lower byte with 1s, else with 0s
		ext.w %0 | copy what is in the lower byte into the upper byte"
		: "=d" (y)										// Output
		: "0" (map->softy)						// Input
	);
	// Draw all Foreground Tiles
	for(; y < plane->SPRHEIGHT; ++y) {
		asm volatile("
			tst.w %0
			smi.b %0 | if negative fill lower byte with 1s, else with 0s
			ext.w %0 | copy what is in the lower byte into the upper byte"
			: "=d" (x)
			: "0" (map->softx)
		);  // Thanks to Samuel Stearly
		for(; x < plane->SPRWIDTH; ++x, ++Tile) {
			if (*Tile)
				GrayTile_Clipped((x<<4) - map->softx, (y<<4) - map->softy, Blocks[*Tile]);
		}
		Tile += Width - (plane->SPRWIDTH + (map->softx < 0));
	}
}

// Original by Thomas Nussbaumer - from the Game Construction Kit
static inline void GrayTile_Clipped(short x, short y, unsigned short* sprite1) {
	register long            addr1   = (long) Hiddenl;
	register long            addr2   = (long) Hiddend;
	register unsigned short* sprite2 = sprite1+16;
	register short           h       = 16;
	register unsigned short  cnt;
	register long            offset;
	
	if (y < -15 || y > plane->PlaneHeight || x < -15 || x > LCD_WIDTH)
		return;  // Completely off screen
	
	if (y < 0) {  // Clip Above
		sprite1 -= y;
		sprite2 -= y;
		h       += y;
		y        = 0;
	} else if (y > plane->PlaneHeight - 1 - h)  // Clip Below
		h = plane->PlaneHeight - y;
	
	if (x + 16 > LCD_WIDTH) {  // Clip Right
		register unsigned short clip=0xffff<<(16-(LCD_WIDTH-x));
		cnt    = 16-(x&15);
		offset = (y<<5)-(y+y)+2*(x>>4);  // Suggested change by Bremen
		addr1  += offset;
		addr2  += offset;
		for (;h;--h,addr1+=30,addr2+=30) {
			*(long*)addr1|=(long)(*sprite1++ & clip)<<cnt;
			*(long*)addr2|=(long)(*sprite2++ & clip)<<cnt;
		}
	} else {
		if (x < 0) {  // Clip Left
			cnt = -x+16;
			offset = (y<<5)-(y+y);
		} else {  // No Horizontal Clipping Necessary
			cnt = 16-(x&15);
			offset = (y<<5)-(y+y)+2*(x>>4);
		}
		addr1  += offset;
		addr2  += offset;
		for (;h;--h,addr1+=30,addr2+=30) {
			*(long*)addr1|=(long)(*sprite1++)<<cnt;
			*(long*)addr2|=(long)(*sprite2++)<<cnt;
		}
	}
}