// C Header File
// Created 9/14/2003; 9:24:11 AM
#define Max_Length						20

typedef struct {
	short type;			// Goalie, Skinny, Average, or Fat
	short x;				// Coordinates of Plr
	short y;
	short addx;			// Direction Plr is moving
	short addy;
	short Control;	// Does the Plr control the puck?
	short delay;		// For friction with the ice
	short face;			// Which Direction the Plr is facing (Left or Right)
	short team;			// Team 1 or 2
	short No;				// 0, 1, or 2 (3 Plrs on a team)
	short anim;			// For animating the Plr
	short anim_delay;
	short Shooting;	// For animating the Plr when shooting
} Plr;

// Team1 and Team2
typedef struct {
	Plr *plrs[3];
	short score;
	short No;
	short Conference;
} Team;

typedef struct {
	short Is_Controlled;
	short x;
	short y;
	short addx;
	short addy;
	short Oldx;
	short Oldy;
} Puck;

// Scrolling Variables
typedef struct {
	short camera_x;
	short camera_y;
	short softx;
	short softy;
} Map;

// Game Settings
typedef struct {
	short Status;
	short Mode;
	short Difficulty;
	short Alert;
	short Shooting;
	short Last_Controlled;
	short Changing;
	unsigned char No_Teams[2];
	char Teams_Changed;
	char Friction;
	char Distortion;
} Game;

typedef void (*P2Func)(void);

typedef struct {
	char Item[Max_Length];
} menu;

typedef struct {
	volatile short Mseconds50;
	volatile short Seconds;
	volatile short Minutes;
	volatile short Reset_Time;
	volatile short Running;
	short Time_Limit;
} Clock;

// Each team in the Western and Eastern conference is a Names struct
typedef struct {
	char TeamName[13];
	char PlrNames[3][23];
	char Formation;
	char Types[2];
} Names;

// Used for calc-calc Compatability
typedef struct {
	short SPRWIDTH;
	short SPRHEIGHT;
	short PlaneHeight;
	short Camerax_1;
	short Camerax_2;
	short Camerax_3;
	short Camerax_4;
	short Cameray_1;
	short Cameray_2;
} Plane;

typedef struct {  //RowKey
  short Row;
  short Key;
} RowKey;

typedef struct {
	RowKey Keys[11];
	char Difficulty;
	char Time_Limit;
	char Speed;
} config;